       **********  JOBCOSTS COMMAND FILE   **********
* Provides summaries of costs by client and job number.  This can
* also be used to summarize all office categories, since they fall
* into these fields.
*      REPORTS ARE BY JOB NUMBER.  Client code is used only in the heading.
* The report is actually prepared based on the job number, so accuracy is
* critical.
*******************************************************************

* First, check to see whether there are still costs that have not been
* posted into the Costbase from the Postfile
USE Postfile
COUNT FOR .NOT. DELETED() TO Any
IF Any > 0
   @ 15, 0
   ? 'There are '+STR(Any,5)+' entries in the Postfile.'
   ? 'Do you still want to do the Job Costs (Y or N).'
   WAIT TO Continue
   IF UPPER(Continue) <> 'Y'
      RETURN
   ENDIF
ENDIF


SET MARGIN TO 8
RESTORE FROM Konstant

* Initialize memory variables
Today = DATE()
Random = 0
Again = ' '

DO WHILE UPPER(Again) <> 'F'
   MClient = '   '
   MJob_Nmbr = '    '
   Hardcopy = ' '
   Getting = ' '
   Number = 'N'

   CLEAR
   DO WHILE UPPER(Getting) <> 'F'
      @  2,11 SAY ' JOB COST SUMMARY :'
      @  4,11 SAY 'ENTER CLIENT CODE ' GET MClient
      @  5,11 SAY ' ENTER JOB NUMBER ' GET MJob_Nmbr
      @  6,11 SAY '       P to PRINT ' GET Hardcopy
      @  7,11 SAY 'SHOW BILL NUMBERS ' GET Number
      READ

     IF VAL(MJob_Nmbr) >99 .AND. VAL(MJob_Nmbr) <1000  .OR. VAL(MJob_Nmbr) <=0
	 * Clear to end of screen
	 @ 8, 0 CLEAR
	 ? '        The JOB NUMBER is wrong.'
	 ? '        Agency jobs are 2-digits,'
	 ? '        Client jobs are 4-digits.'
	 ?
	 ? '        F if FINISHED,'
	 ? '     <Return> to fix it.'
	 WAIT TO Getting
	 @  8, 0 CLEAR
	 Again = Getting
      ELSE
	 IF ' ' $ MClient
	    @  8, 0 CLEAR
	    ? '     CLIENT code is 3 characters.'
	    ?
	    ? '     F if Finished,'
	    ? '  <Return> to continue.'
	    WAIT TO Getting
	    @  8, 0 CLEAR
	    Again = Getting
	 ELSE
	    Getting = 'F'
	 ENDIF
      ENDIF
   ENDDO

   IF UPPER(Again) <> 'F'
      @ 8,0 CLEAR
      ACCEPT '    OPTIONAL JOB DESCRIPTION  ' TO Message
      Message = TRIM(UPPER(Message))
      MClient = UPPER(MClient)
      Hardcopy = UPPER(Hardcopy)
      Number = UPPER(Number)

      * Set color to inverse
      SET COLOR TO /W
      @ 4,30 SAY MClient
      @ 6,30 SAY Hardcopy
      @ 7,30 SAY Number
      @ 9,30 SAY Message
      * Reset color to normal
      SET COLOR TO W
      ?
      ?
      ACCEPT 'Type C to CHANGE any entries' TO Changes
      CLEAR
      IF UPPER(Changes) = 'C'
	 Again = ' '
      ELSE
	 IF Hardcopy = 'P'
	    SET PRINT ON
	 ENDIF

	 IF Number = 'Y'
	    Switch = 'Bill #'
	 ELSE
	    Switch = ''
	 ENDIF

	 ? Today + ':  COST SUMMARY' + ' FOR &MClient-'
	 ?? &MJob_Nmbr
	 ? SPACE(12) + Message
	 ?
	 ? 'DATE     NAME                 DESCRIPTION                AMOUNT';
	    +' &Switch'
	 ?
	 USE CostBase INDEX CostJobs
	 IF Number = 'Y'
	    Switch = ',Bill_Nmbr'
	 ELSE
	    Switch = ''
	 ENDIF

	 STORE 0 TO Cost, Inside, Buyouts, HowMany, LineCnt, Spacer
	 FIND &MJob_Nmbr
	 IF RECNO() <> 0
	    DO WHILE Job_Nmbr = VAL(MJob_Nmbr) .AND. .NOT. EOF()
	       IF .NOT. DELETED()
		  ? Bill_Date, Name, Descrip+'   ', Amount &Switch

		  IF Check_Nmbr = '--'
		     Inside = Inside + Amount
		  ELSE
		     Buyouts = Buyouts + Amount
		  ENDIF
		  Cost = Cost + Amount

		  LineCnt = LineCnt + 1
		  Spacer = Spacer + 1

		  IF Spacer = 10
		     Spacer = 0
		     ?
		  ENDIF

		  IF LineCnt = 50
		     * formfeed with print on
		     IF Hardcopy = 'P'
			SET CONSOLE OFF
			? CHR(12)
			SET CONSOLE ON
			SET PRINT OFF
		     ENDIF

		     STORE 0 TO LineCnt, Spacer

		     ? 'DATE    NAME                 DESCRIPTION';
		       + SPACE(16) + 'AMOUNT'
		     ?
		  ENDIF
	       ENDIF
	       SKIP
	    ENDDO
	 ENDIF


	 ? SPACE(54) + '----------'
	 ? STR(Inside,9,2) +' inside costs  + '+ STR(Buyouts,9,2);
			     + ' buyouts =  TOTAL: ' + STR(Cost,9,2)
	 ?
	 Min = Inside + 1.18 * Buyouts
	 ? SPACE(15) + 'IF ALL COSTS ARE IN, bill this amount: ' + STR(Min,9,2)
	 ?
	 LineCnt = LineCnt + 5
	 Spacer = 0
	 IF LineCnt = 40
	    LineCnt = 0
	    IF Hardcopy = 'P'
	       SET CONSOLE OFF
	       ? CHR(12)
	       SET CONSOLE ON
	       SET PRINT OFF
	    ENDIF
	 ELSE
	    ?
	    ?
	    ?
	 ENDIF

	 USE Billings INDEX BillJobs
	 ? 'BILLED TO DATE FOR &MClient-'
	 ?? &MJob_Nmbr
	 ?
	 ? 'DATE   INV#    TAXABLE        TAX    TAX FREE  DESCRIPTION'
	 ?
	 LineCnt = LineCnt + 4
	 STORE 0 TO Cost, T, S, F

	 FIND &MJob_Nmbr
	 IF RECNO() <> 0
	    DO WHILE Job_Nmbr = VAL(MJob_Nmbr) .AND. .NOT. EOF()
	       IF .NOT. DELETED()
		  ? Inv_Date, Inv_Nmbr, STR(Taxable,9,2) + '   ' +;
		       STR(Sales_Tax,9,2) + ' ', TaxFree, Descrip
		  T = T + Taxable
		  S = S + Sales_Tax
		  F = F + TaxFree
		  LineCnt = LineCnt + 1
		  Spacer = Spacer + 1

		  IF Spacer = 10
		     Spacer = 0
		     ?
		  ENDIF

		  IF LineCnt = 50
		     LineCnt = 0
		     Spacer = 0

		     IF Hardcopy = 'P'
			SET CONSOLE OFF
			? CHR(12)
			SET CONSOLE ON
			SET PRINT OFF
		     ENDIF

		     ? 'DATE   INV#    TAXABLE        TAX    TAX FREE';
					      + '  DESCRIPTION'
		     ?
		  ENDIF
	       ENDIF
	       SKIP
	    ENDDO
	 ENDIF


	 Cost = T + S + F
	 ? SPACE(15) + '---------  ---------   ---------'
	 ? ' SUB-TOTALS:  '+STR(T,9,2) + '  '+STR(S,9,2)+'   ' + STR(F,9,2)
	 ? SPACE(37) +	'----------'
	 ? SPACE(30) +	'BILLED ' + STR(T+F,9,2)
	 IF S > 0
	    ?? ' + tax.'
	 ENDIF

	 IF Hardcopy = 'P'
	    SET CONSOLE OFF
	    ? CHR(12)
	    SET CONSOLE ON
	    SET PRINT OFF
	 ENDIF

	 ? '     F if Finished,'
	 ? '  <Return> to continue.'
	 WAIT TO Again
      ENDIF
   ENDIF
ENDDO Again

SET MARGIN TO 15
RETURN
